<id>
Topic Solved
</id>

<version>
1.21
</version>

<mod info>
This is the first version of my topic solved MOD for SMF. This MOD allows you to select boards as "topic solved" boards. These boards will allow the topic started to ask questions and accept/reject answers to them. This is most useful on support boards. There are many settings than can be set up. Including message icons to indicate acceptance/rejection, and changing the background colour of the message to reflect topic starter as well as accepted and rejected messages. All "solved" topics will be marked in the message index with the "solved" topic icon.

At the moment the ONLY images included are basic images for accept / reject. These need to be replaced with ones matching the theme - anyone makes any buttons please give them to me!!

Installation:
* upload the two images to the $themedir/images/english folder
* Upload the TopicSolveddb.php file to the forum root directory and run it ONCE. Then delete it
* Run the MOD file and upload the changes

After installation go to feature settings and make any changes you wish to make. Then go to manage boards and turn the mod on for the board of your choice.

Written By Matthew Wolf (a.k.a Grudge) - me@mattwolf.co.uk
http://www.mymods.co.uk
Copyright 2004 - Neither this package or any of it's contents may be distributed without authorisation
</mod info>

<author>
Grudge
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['topicsolved_enable'] = 'Make this board a \'topic solved\' board';
$txt['topicsolved_desc'] = 'Allow users in this board to accept and reject answers to their quieries';
$txt['topicsolved_title'] = 'Topic Solved Options';
$txt['topicsolvedLockSolved'] = 'Lock a topic when it has been marked as solved';
$txt['topicsolvedAllowReject'] = 'Allow users to reject someone\'s answer on topic solved';
$txt['topicsolvedIconAccept'] = 'Message icon on solved topics / messages';
$txt['topicsolvedIconReject'] = 'Message icon on rejected messages';
$txt['topicsolvedIconStarter'] = 'Message icon on starters messages';
$txt['topicsolvedIconOther'] = 'Message icon on other posters messages';
$txt['topicsolvedBackgroundEnabled'] = 'Should background of message be colored on accepted/rejected messages';
$txt['topicsolvedColorAccept'] = 'Color of background for accepted messages';
$txt['topicsolvedColorReject'] = 'Color of background for rejected messages';
$txt['topicsolvedColorStarter'] = 'Color of background for topic starter messages';
$txt['topicsolved_accept'] = 'Accept';
$txt['topicsolved_reject'] = 'Reject';
$txt['topicsolved_acceptbut'] = 'Accept answer';
$txt['topicsolved_rejectbut'] = 'Reject answer';
</add before>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('text', 'karmaSmiteLabel'),
</search for>

<add after>
		array('heading', &$txt['topicsolved_title']),
			array('check', 'topicsolvedLockSolved'),
			array('check', 'topicsolvedAllowReject'),
		array('rule'),
			array('text', 'topicsolvedIconAccept'),
			array('text', 'topicsolvedIconReject'),
			array('text', 'topicsolvedIconStarter'),
			array('text', 'topicsolvedIconOther'),
		array('rule'),
			array('check', 'topicsolvedBackgroundEnabled'),
			array('text', 'topicsolvedColorAccept'),
			array('text', 'topicsolvedColorReject'),
			array('text', 'topicsolvedColorStarter'),
</add after>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
				'count_posts' => empty($row['countPosts']),
</search for>

<add after>
				'topic_solved' => $row['topicSolved'] == 1,
</add after>

<search for>
			b.boardOrder, b.countPosts, b.memberGroups, b.ID_THEME, b.override_theme,
</search for>

<add after>
			b.topicSolved,
</add after>

<search for>
					countPosts = $_POST[count], ID_CAT = $ID_CAT, ID_PARENT = $ID_PARENT,
</search for>

<add after>
				topicSolved = $_POST[topicsolved],
</add after>

<search for>
		$_POST['count'] = isset($_POST['count']) ? '0' : '1';
</search for>

<add after>
		$_POST['topicsolved'] = isset($_POST['topicsolved']) ? '1' : '0';
</add after>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
							</tr><tr>
								<td>
									<b>', $txt['mboards_count_posts'], '</b><br />
									', $txt['mboards_count_posts_desc'], '<br /><br />
								</td>
								<td valign="top" align="right">
									<input type="checkbox" name="count" ', $context['board']['count_posts'] ? ' checked="checked"' : '', ' class="check" />
								</td>
</search for>

<add after>
							</tr><tr>
								<td>
									<b>', $txt['topicsolved_enable'], '</b><br />
									', $txt['topicsolved_desc'], '<br /><br />
								</td>
								<td valign="top" align="right">
									<input type="checkbox" name="topicsolved" ', $context['board']['topic_solved'] ? ' checked="checked"' : '', ' class="check" />
								</td>
</add after>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
				mem.realName" . (!empty($topic) ? ", b.ID_BOARD" : '') . ", b.childLevel,
</search for>

<add after>
				b.topicSolved,
</add after>

<search for>
				'num_topics' => $row['numTopics'],
</search for>

<add after>
				'topicSolved' => $row['topicSolved'],
</add after>

<edit file>
$sourcedir/Post.php
</edit file>

<search for>
	if (empty($board) && !$context['make_event'])
		fatal_lang_error('smf232', false);
</search for>

<add after>
	if ($board_info['topicSolved'])
		$context['topicSolved'] = 1;
</add after>

<search for>
		// By default....
		$context['use_smileys'] = true;
		$context['icon'] = 'xx';
</search for>

<add after>
		if ($board_info['topicSolved'])
			$context['icon'] = empty($topic) || $ID_MEMBER == $ID_MEMBER_POSTER ? $modSettings['topicsolvedIconStarter'] : $modSettings['topicsolvedIconOther'];
</add after>

<search for>
	obExit(false);
}
</search for>

<add after>
function topicSolved()
{
	global $txt, $scripturl, $topic, $db_prefix, $modSettings, $board, $ID_MEMBER, $user_info;
	global $board_info, $settings, $sourcedir;

	if (!isset($topic) || !isset($_REQUEST['msg']))
		fatal_error("Hacker...");
	$msg = $_REQUEST['msg'];
	
	$accept = isset($_REQUEST['accept']) ? 1 : -1;

	// Check user has permission to do this
	$request = db_query("
		SELECT m.ID_MSG, m.ID_MEMBER, m.topicSolved
		FROM {$db_prefix}topics AS t
			LEFT JOIN {$db_prefix}messages AS m ON (m.ID_MSG = t.ID_FIRST_MSG)
		WHERE t.ID_TOPIC = $topic
		LIMIT 1", __FILE__, __LINE__);
	list ($FIRST_MSG, $ID_MEMBER_POSTER, $firstSolved) = mysql_fetch_row($request);
	mysql_free_result($request);

	if ($ID_MEMBER != $ID_MEMBER_POSTER && !isset($user_info['is_admin']))
		fatal_error("Hacker... ");

	// If we are accepting
	if ($accept == 1)
	{
		// Reset any previous accepts
		db_query("
			UPDATE {$db_prefix}messages
			SET topicSolved = 0, icon = '$modSettings[topicsolvedIconOther]'
			WHERE ID_TOPIC = $topic AND topicSolved = 1 AND ID_MEMBER != $ID_MEMBER_POSTER", __FILE__, __LINE__);
		db_query("
			UPDATE {$db_prefix}messages
			SET topicSolved = 0, icon = '$modSettings[topicsolvedIconStarter]'
			WHERE ID_TOPIC = $topic AND topicSolved = 1 AND ID_MEMBER = $ID_MEMBER_POSTER", __FILE__, __LINE__);
		// Update top message
		db_query("
			UPDATE {$db_prefix}messages
			SET topicSolved = 2, icon = '$modSettings[topicsolvedIconAccept]'
			WHERE ID_MSG = $FIRST_MSG", __FILE__, __LINE__);
	}
	elseif ($firstSolved == 2)
	{
		// Nothing specific - unless first message was solved and rejecting solved message
		$request = db_query("
			SELECT topicSolved
			FROM {$db_prefix}messages
			WHERE ID_MSG = $msg
			LIMIT 1", __FILE__, __LINE__);
		list ($prevSolved) = mysql_fetch_row($request);
		mysql_free_result($request);
		// Lots of work sorting this out
		if ($prevSolved > 0)
		{
			// Unlock thread
			db_query("
				UPDATE {$db_prefix}topics
				SET locked = 0
				WHERE ID_TOPIC = $topic", __FILE__, __LINE__);
			// Set first message back to normal
			db_query("
				UPDATE {$db_prefix}messages
				SET topicSolved = 0, icon = '$modSettings[topicsolvedIconStarter]'
				WHERE ID_MSG = $FIRST_MSG", __FILE__, __LINE__);
		}

	}
	// Set the message as accepted
	$icon = $accept == 1 ? 'topicsolvedIconAccept' : 'topicsolvedIconReject';
	db_query("
		UPDATE {$db_prefix}messages
		SET topicSolved = $accept, icon = '$modSettings[$icon]'
		WHERE ID_MSG = $msg AND ID_MSG != $FIRST_MSG", __FILE__, __LINE__);
	// Lock it?
	if ($accept == 1 && !empty($modSettings['topicsolvedLockSolved']))
	db_query("
		UPDATE {$db_prefix}topics
		SET locked = 1
		WHERE ID_TOPIC = $topic", __FILE__, __LINE__);

	// Back to the message
	redirectexit('topic=' . $topic . '/new#new');
}
</add after>

<edit file>
$themedir/Post.template.php
</edit file>

<search for>
							<tr>
								<td align="right">
									<b>', $txt[71], ':</b>
</search for>

<add before>
								';
	if (isset($context['topicSolved']))
	{
		echo'
			<input type="hidden" name="icon" value="' . $context['icon'] . '" />';
	}
	else
	{
		echo'
</add before>

<search for>
	if ($context['make_poll'])
	{
		echo '
							<tr>
</search for>

<add before>
	}
	// Grudge's topic solved uninstall text so boardmod doesn't go insane - ladeda
</add before>

<edit file>
index.php
</edit file>

<search for>
		'theme' => array('Themes.php', 'ThemesMain'),
</search for>

<add after>
		'topicsolve' => array('Post.php', 'topicSolved'),
</add after>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
		if ($message['can_modify'])
			echo '
									<a href="', $scripturl, '?action=post;msg=', $message['id'], ';topic=', $context['current_topic'], '.', $context['start'], ';sesc=', $context['session_id'], '">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/modify.gif" alt="' . $txt[66] . '" border="0" />' : $txt[17]), '</a>';
</search for>

<add after>
		if (($context['user']['started'] || $context['user']['is_admin']) && isset($context['topicSolved']))
			echo '
									<a href="', $scripturl, '?action=topicsolve;msg=', $message['id'], ';topic=', $context['current_topic'], ';accept=1">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/accept.gif" alt="' . $txt['topicsolved_acceptbut'] . '" border="0" />' : $txt['topicsolved_accept']), '</a>
									<a href="', $scripturl, '?action=topicsolve;msg=', $message['id'], ';topic=', $context['current_topic'], '">', ($settings['use_image_buttons'] ? '<img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/reject.gif" alt="' . $txt['topicsolved_rejectbut'] . '" border="0" />' : $txt['topicsolved_reject']), '</a>';
</add after>

<search for>
				<input type="hidden" name="icon" value="xx" />
</search for>

<replace>
';
	if (isset($context['topicSolved']))
		echo '			<input type="hidden" name="icon" value="' . $modSettings['topicsolvedIcon' . ($context['user']['started'] ? 'Starter' : 'Other')] . '"/>';
	else
		echo '			<input type="hidden" name="icon" value="xx" />';
echo'
</replace>

<search for>
			<tr><td class="', $message['alternate'] == 0 ? 'windowbg' : 'windowbg2', '">';
</search for>

<replace>
			<tr><td class="', $message['alternate'] == 0 ? 'windowbg' : 'windowbg2', '" ' . (isset($message['messageColor']) ? 'style="background-color: ' . $message['messageColor'] . '"' : '') . '>';
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	// Did this user start the topic or not?
	$context['user']['started'] = $ID_MEMBER == $topicinfo['ID_MEMBER_STARTED'] && !$user_info['is_guest'];
</search for>

<add after>
	if ($board_info['topicSolved'])
	{
		$context['topicSolved'] = 1;
		$context['user']['memberStarted'] = $topicinfo['ID_MEMBER_STARTED'];
	}

</add after>

<search for>
				smileysEnabled, posterName, posterEmail,
</search for>

<add after>
				topicSolved,
</add after>

<search for>
	if (empty($options['view_newest_first']))
		$counter++;
	else
		$counter--;
</search for>

<add after>
	if (isset($context['topicSolved']) && !empty($modSettings['topicsolvedBackgroundEnabled']))
	{
		if ($message['topicSolved'] == -1)
			$output['messageColor'] = $modSettings['topicsolvedColorReject'];
		elseif ($message['topicSolved'] == 1 || $message['topicSolved'] == 2)
			$output['messageColor'] = $modSettings['topicsolvedColorAccept'];
		elseif ($message['ID_MEMBER'] == $context['user']['memberStarted'])
			$output['messageColor'] = $modSettings['topicsolvedColorStarter'];
	}
</add after>